#include	<gsl/gsl_cdf.h>
#include	<iostream>
#include	<stdint.h>
#include	<cstring>
#include	<vector>
#include	<string>
#include	<zlib.h>
#include	<cmath>
using	namespace	std;
typedef	unsigned	uint;
typedef	float	fast;
typedef	double	real;
#define	Gender_Female	0
#define	Gender_Male	1

class	Model{
private:
	void	model_a(void);
	void	model_x(void);
	void	model_y(void);
	void	model_m(void);
public:
	static	real	maa,	mab,	mbb,	pre,	fst,	out;
	static	vector<char>	gen;
			
	char	chr[16],	all[4];
	uint32_t	pos;
	vector<fast>	cnt;
	fast	eaa,	eab,	ebb,	sig;
	void	estimate(void);
	void	write(gzFile	F);
};

real	Model::maa=0.995;
real	Model::mab=0.500;
real	Model::mbb=0.010;
real	Model::fst=0.13;
real	Model::out=1e-6;
real	Model::pre=100;
vector<char>	Model::gen;

void	Model::estimate(void){
	if(strchr(chr,	'X')!=NULL){	model_x();	return;	}
	if(strchr(chr,	'Y')!=NULL){	model_y();	return;	}
	if(strstr(chr,	"MT")!=NULL){	model_m();	return;	}
	model_a();
}
/*
void	Model::model_a(void){
	uint	in=cnt.size()/2;
	real	na=0,	nb=0;
	vector<real>	normal;	normal.resize(in);
	
	for(uint	i=0;	i<in;	i++){
		fast	ta=cnt[i*2],	tb=cnt[i*2+1];
		normal[i]=lgamma(ta+tb+1)-lgamma(ta+1)-lgamma(tb+1);
		na+=ta;	nb+=tb;
	}
	if(nb<1||na<1){	eaa=maa;	eab=mab;	ebb=mbb;	sig=0;	return;	}
	if(na<nb){
		for(uint	i=0;	i<in;	i++){
			fast	t=cnt[i*2];	cnt[i*2]=cnt[i*2+1];	cnt[i*2+1]=t;
		}
		char	a=tolower(all[1]);
		all[1]=all[0];	all[0]=a;
		real	x=na;	na=nb;	nb=x;
	}
	else	all[1]=tolower(all[1]);

	real	m=(na+maa*pre)/(na+nb+pre),	m0,	la,	lb,	wa,	wb;
	real	fre,	old,	aa,	ab,	bb;
	real	naa,	nab,	nbb,	laa,	lab,	lbb;
	real	aap,	aaq,	abp,	abq,	bbp,	bbq;
	fre=0.667;	naa=4;	nab=4;	nbb=1;	aa=0.95;	ab=0.5;	bb=0.05;
	do{
		m0=m;	old=fre;
		la=log(m);	lb=log(1-m);	wa=0;	wb=0;
		laa=log(fst*fre+(1-fst)*fre*fre);
		lab=log((1-fst)*2*fre*(1-fre));
		lbb=log(fst*(1-fre)+(1-fst)*(1-fre)*(1-fre));
		aap=log(aa);	abp=log(ab);	bbp=log(bb);
		aaq=log(1-aa);	abq=log(1-ab);	bbq=log(1-bb);
		naa=nab=nbb=0;
		real	paa=0,	pab=0,	pbb=0,	qaa=0,	qab=0,	qbb=0;
		fast	*p=&cnt[0];
		for(uint	i=0;	i<in;	i++){
			fast	ta=*p++,	tb=*p++;
			real	nor=normal[i];
			real	wn=(1-out)*exp(nor+ta*la+tb*lb);
			real	wo=out/(ta+tb+1);
			wn*=1.0/(wn+wo);	wa+=wn*ta;	wb+=wn*tb;
			real	taa=exp(laa+ta*aap+tb*aaq+nor);
			real	tab=exp(lab+ta*abp+tb*abq+nor);
			real	tbb=exp(lbb+ta*bbp+tb*bbq+nor);
			real	s=1.0/(taa+tab+tbb);	taa*=s;	tab*=s;	tbb*=s;
			paa+=taa*ta;	pab+=tab*ta;	pbb+=tbb*ta;
			qaa+=taa*tb;	qab+=tab*tb;	qbb+=tbb*tb;
			naa+=taa;	nab+=tab;	nbb+=tbb;
		}
		fre=0.5*(2*naa+nab+1-out)/(naa+nab+nbb+0.5);
		aa=(paa+maa*pre)/(paa+qaa+pre);
		ab=(pab+mab*pre)/(pab+qab+pre);
		bb=(pbb+mbb*pre)/(pbb+qbb+pre);
		m=(wa+maa*pre)/(wa+wb+pre);
	}while(fabs(m-m0)>1e-5||fabs(fre-old)>1e-4);

	real	l0=(lgamma(pre)-lgamma((maa)*pre)-lgamma(mbb*pre)+((maa)*pre-1)*la+(mbb*pre-1)*lb)*(1-out);
	real	l1=(lgamma(pre)-lgamma((maa)*pre)-lgamma(mbb*pre)+((maa)*pre-1)*aap+(mbb*pre-1)*aaq)*(fst*fre+(1-fst)*fre*fre);
	l1+=(lgamma(pre)-lgamma(mab*pre)-lgamma(mab*pre)+(mab*pre-1)*abp+(mab*pre-1)*abq)*((1-fst)*2*fre*(1-fre));
	l1+=(lgamma(pre)-lgamma(mbb*pre)-lgamma((maa)*pre)+(mbb*pre-1)*bbp+((maa)*pre-1)*bbq)*(fst*(1-fre)+(1-fst)*(1-fre)*(1-fre));

	fast	*p=&cnt[0];
	for(uint	i=0;	i<in;	i++){
		fast	ta=*p++,	tb=*p++;
		real	nor=normal[i];
		l0+=log((1-out)*exp(nor+ta*la+tb*lb)+out/(ta+tb+1));
		l1+=log(exp(laa+ta*aap+tb*aaq+nor)+exp(lab+ta*abp+tb*abq+nor)+exp(lbb+ta*bbp+tb*bbq+nor));
	}
	sig=2*(l1-l0);	eaa=aa;	eab=ab;	ebb=bb;
}
*/
void	Model::model_a(void){
	uint	in=cnt.size()/2;
	real	na=0,	nb=0;
	vector<real>	normal;	normal.resize(in);
	for(uint	i=0;	i<in;	i++){
		fast	ta=cnt[i*2],	tb=cnt[i*2+1];
		normal[i]=lgamma(ta+tb+1)-lgamma(ta+1)-lgamma(tb+1);
		na+=ta;	nb+=tb;
	}
	if(nb<1||na<1){	eaa=maa;	eab=mab;	ebb=mbb;	sig=0;	return;	}
	if(na<nb){
		for(uint	i=0;	i<in;	i++){
			fast	t=cnt[i*2];	cnt[i*2]=cnt[i*2+1];	cnt[i*2+1]=t;
		}
		char	a=tolower(all[1]);
		all[1]=all[0];	all[0]=a;
		real	x=na;	na=nb;	nb=x;
	}
	else	all[1]=tolower(all[1]);

	real	p=na/(na+nb),	v0=na*nb/(na+nb),	v1=0,	v2=0;
	sig=0;
	for(uint	i=0;	i<in;	i++){
		fast	ta=cnt[i*2],	tb=cnt[i*2+1],	e=p*(ta+tb);
		v1+=(ta-e)*(ta-e);	
		v2+=fmin(8*fmin(ta*ta,	tb*tb),	0.25*(ta-tb)*(ta-tb));
	}
//	sig=(v1-v0+1)/(v2+1);
	sig=(v1+1)/(v0+1);

	real	fre,	old,	aa,	ab,	bb;
	real	naa,	nab,	nbb,	laa,	lab,	lbb;
	real	aap,	aaq,	abp,	abq,	bbp,	bbq;
	fre=0.667;	naa=4;	nab=4;	nbb=1;	aa=0.95;	ab=0.5;	bb=0.05;
	do{
		old=fre;
		laa=log(fst*fre+(1-fst)*fre*fre);
		lab=log((1-fst)*2*fre*(1-fre));
		lbb=log(fst*(1-fre)+(1-fst)*(1-fre)*(1-fre));
		aap=log(aa);	abp=log(ab);	bbp=log(bb);
		aaq=log(1-aa);	abq=log(1-ab);	bbq=log(1-bb);
		naa=nab=nbb=0;
		real	paa=0,	pab=0,	pbb=0,	qaa=0,	qab=0,	qbb=0;
		fast	*p=&cnt[0];
		for(uint	i=0;	i<in;	i++){
			fast	ta=*p++,	tb=*p++;
			real	nor=normal[i];
			real	taa=exp(laa+ta*aap+tb*aaq+nor);
			real	tab=exp(lab+ta*abp+tb*abq+nor);
			real	tbb=exp(lbb+ta*bbp+tb*bbq+nor);
			real	s=1.0/(taa+tab+tbb);	taa*=s;	tab*=s;	tbb*=s;
			paa+=taa*ta;	pab+=tab*ta;	pbb+=tbb*ta;
			qaa+=taa*tb;	qab+=tab*tb;	qbb+=tbb*tb;
			naa+=taa;	nab+=tab;	nbb+=tbb;
		}
		fre=0.5*(2*naa+nab+1-out)/(naa+nab+nbb+0.5);
		aa=(paa+maa*pre)/(paa+qaa+pre);
		ab=(pab+mab*pre)/(pab+qab+pre);
		bb=(pbb+mbb*pre)/(pbb+qbb+pre);
	}while(fabs(fre-old)>1e-4);		
	eaa=aa;	eab=ab;	ebb=bb;	
}

void	Model::model_x(void){

}

void	Model::model_y(void){

}

void	Model::model_m(void){

}

void	Model::write(gzFile	F){
	uint	in=cnt.size()/2;
	real	aap=log(eaa),	abp=log(eab),	bbp=log(ebb);
	real	aaq=log(1-eaa),	abq=log(1-eab),	bbq=log(1-ebb);
	gzprintf(F,	"\n%s\t%u\t%s",	chr,	pos,	all);
	for(uint	i=0;	i<in;	i++){
		fast	ta=cnt[i*2],	tb=cnt[i*2+1];
		fast	taa=ta*aap+tb*aaq;
		fast	tab=ta*abp+tb*abq;
		fast	tbb=ta*bbp+tb*bbq;
		if(taa>tab&&taa>tbb){	tab=expf(tab-taa);	tbb=expf(tbb-taa);	taa=1;	}
		else	if(tab>taa&&tab>tbb){	taa=expf(taa-tab);	tbb=expf(tbb-tab);	tab=1;	}
		else{	taa=exp(taa-tbb);	tab=expf(tab-tbb);	tbb=1;	}
		fast	s=1/(taa+tab+tbb);	taa*=s;	tab*=s;	tbb*=s;
		gzprintf(F,	"\t%g %g",	tab,	tbb);
	}
}

